
(********************************************************)
(*                                                      *)
(*           Sample Game for Delphi 5                   *)
(*        Copyright (c) 2001 by Adam Boduch             *)
(*          HTTP://WWW.PROGRAMOWANIE.OF.PL              *)
(*              E - mail: boduch@poland.com             *)
(*      Build: 10.01.2001 r.                            *)
(*                                                      *)
(********************************************************)

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Gauges, Samo {<-- oto nasz modul! };

type
  TMainForm = class(TForm)
    CarBox: TComboBox;
    Polecenie: TRadioGroup;
    grpSetup: TGroupBox;
    Label1: TLabel;
    edtSpeed: TEdit;
    Label2: TLabel;
    Panel1: TPanel;
    gFuel: TGauge;
    gOpony: TGauge;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    edtFuel: TEdit;
    btnSendMessage: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    tmrOpony: TTimer;
    btnCh: TButton;
    tmrFuel: TTimer;
    btnFuel: TButton;
    Mess: TListBox;
    procedure CarBoxChange(Sender: TObject);
    procedure btnSendMessageClick(Sender: TObject);
    procedure tmrOponyTimer(Sender: TObject);
    procedure btnChClick(Sender: TObject);
    procedure tmrFuelTimer(Sender: TObject);
    procedure btnFuelClick(Sender: TObject);
  private
    Car : TSamochod; // zmienna wskazujaca na nowa klase
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.CarBoxChange(Sender: TObject);
begin
{
  W zaleznosci od wybranej pozycji w komponencie CarBox
  tworzona jest klasa z odpowiednim parametrem.
}
  case CarBox.ItemIndex of
    0: Car := TSamochod.Create(caPorshe);
    1: Car := TSamochod.Create(caFerrari);
    2: Car := TSamochod.Create(caLamborgini);
  end;
end;

procedure TMainForm.btnSendMessageClick(Sender: TObject);
var
  Odp : String;  // zmienna przechowywa bdzie odpowied
begin
{
  Procedura ta przekazuje funkcjom zawartym w module "Samo"
  odpowiednie parametry, ktore ustalane sa przez uzytkownika.
}
  Car.Go(StrToInt(edtSpeed.Text), Polecenie.ItemIndex, Odp);
  Mess.Items.Add(Odp);


// uruchom Timer'y
  tmrOpony.Enabled := True;
  tmrFuel.Enabled := True;

{
  Na podst. aktualnej predkosci ustal czestotliwosc wystepowania
  zdarzenia.
  Innymi slowy w zaleznosci od predkosci ustalany jest podtep w
  zuzyciu opon.
}
  case Car.JakaPredkosc of
    0..50 : tmrOpony.Interval := 10000;
    51..100: tmrOpony.Interval := 5000;
    101..150: tmrOpony.Interval := 2500;
    151..200: tmrOpony.Interval := 1300;
    201..250: tmrOpony.Interval := 700;
    251..310: tmrOpony.Interval := 500;
  end;

  tmrFuel.Interval := Car.Interval; // ustaw czestotliowsc wystepowania zdarznia na podst. zmiennej z modulu "Samo"
end;

procedure TMainForm.tmrOponyTimer(Sender: TObject);
begin
// Jezeli predkosc wynosi 0 to nie przestan naliczac zuzycie opon
  if Car.JakaPredkosc = 0 then Exit;
  
  gOpony.Progress := Pred(gOpony.Progress); // zmniejsz wskaznik postepu
  case gOpony.Progress of // zmieniaj kolor komponentu w zaleznosci od postepu
    0..19: gOpony.Color := clWhite;
    20..39: gOpony.Color := clAqua;
    40..69: gOpony.Color := clBlue;
    70..89: gOpony.Color := clNavy;
    90..100: gOpony.Color := clBlack;
  end;
{
  Jezeli postep zaznaczony na komponencie "Gauge" osiagnie niepokojacy wynik,
  czyli bedzie brakowalo paliwa :) wyswietl odpowiedni komunikat w Memo
}
  if gOpony.Progress = 50 then
    Mess.Items.Add('Mam kiepskie ogumienie. Naleaoby zjecha do PitSop-u');
  if gOpony.Progress = 10 then
    Mess.Items.Add('Jeeli nie zmienie opon to si rozbije!');
  if gOpony.Progress = 0 then
    Mess.Items.Add('AAAA!!! Robiem sie!');
end;

procedure TMainForm.btnChClick(Sender: TObject);
begin
{
  Wywolaj funkcje "ZmienOpony" z modulu "Samo" jezeli nacisniety
  zostanie przycisk. Jezeli nie jestes w pitstopie to generowany
  zostaje komunikat w Memo
}
  if Polecenie.ItemIndex = 2 then
    gOpony.Progress := Car.ZmienOpony else
  Mess.Items.Add('Musz wjecha do PitStopu');
end;

procedure TMainForm.tmrFuelTimer(Sender: TObject);
begin
  if Car.JakaPredkosc = 0 then Exit; // Jezeli predkosc wynosi 0 to nie rob nic

  gFuel.Progress := Car.Paliwo; // zaznacz na komponencie ilosc paliwa
    if gFuel.Progress = 50 then
      Mess.Items.Add('Mam tylko poowe zbiornika. Naleaoby zwikszy t ilo');
    if gFuel.Progress = 10 then
      Mess.Items.Add('Zaraz si zatrzymam! Musz zjecha to PitStopu!');
    if gFuel.Progress = 0 then
      Mess.Items.Add('Koniec jazdy. Brak mi paliwa!');
end;

procedure TMainForm.btnFuelClick(Sender: TObject);
begin
{
  Ta procedura natomiast uzupelnia zapas paliwa. Ponizsze
  warunki sprawdzaja, czy nie probujesz dolac wiecej paliwa niz
  mozliwe to jest do pomieszczenia w zbiorniku.
  Jezeli ilosc wpisana w "edtFuel" bedzie przekraczac 'niedobytek'
  w Gauge to odpowiednio zmniejsz ta ilosc
}
  if Polecenie.ItemIndex = 2 then begin
    if StrToInt(edtFuel.Text) > (100 - gFuel.Progress) then
      edtFuel.Text := IntToStr(100 - gFuel.Progress);
    gFuel.Progress := Car.Zatankuj(StrToInt(edtFuel.Text)); // zatankuj tyle ile jest wpisane w kontrolce "edtFuel"
  end else
  Mess.Items.Add('Musz najpierw wjecha do PitStopu'); // Jezeli nie jestes w PitStopie wyswietl komunikat
end;

end.
