
{
  Copyright (c) Adam Boduch 2001
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    lblName: TLabel;
    edtName: TEdit;
    lblMail: TLabel;
    edtMail: TEdit;
    lblTel: TLabel;
    edtTel: TEdit;
    lblRecords: TLabel;
    cmCounts: TComboBox;
    btnAdd: TButton;
    procedure btnAddClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmCountsChange(Sender: TObject);
  private
    procedure ShowRecords;
    procedure LoadRecord(Num : Longint);
  end;

{ w tym rekordzie przechowywane bd dane  }
  TDatBase = packed record
    Name  : String[30]; // imi
    Mail  : String[30]; // e-mail
    Number: Int64; // telefon
  end;

const DatName = 'data.dbt';  // w tym pliku przechowywane bd dane

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.btnAddClick(Sender: TObject);
var
  DatBase : file of TDatBase;  // plik typowany
  DB : TDatBase;
  FSize : Integer;
begin
  AssignFile(DatBase, DatName);
  if not FileExists(DatName) then // jezeli plik nie istnieje...
    ReWrite(DatBase){ stworz go } else ReSet(DatBase); // w przeciwnym wypadku - otwrz

  FSize := FileSize(DatBase); // odczytaj rozmiar pliku
  if FSize > 0 then  // jezeli cos juz w nim jest zapisane...
    Seek(DatBase, FSize); // przesu na sam koniec

 { przypisz wszystkie dane z komponentw do rekordu  }
  DB.Name := edtName.Text;
  DB.Mail := edtMail.Text;
  DB.Number := StrToInt(edtTel.Text);
  Write(DatBase, DB); // zapisz rekord do pliku
  CloseFile(DatBase); // zamknij
  ShowRecords; // odwie list rekordw
end;

procedure TMainForm.LoadRecord(Num: Integer);
var
  DatBase : file of TDatBase;
  DB : TDatBase;
begin
  AssignFile(DatBase, DatName);
  Reset(DatBase);

  Seek(DatBase, Num); // przesu na rekord, ktry chcesz odczyta
  Read(DatBase, DB);  // odczytaj do rekordu
  { przypisz dane z rekordu do komponentw }
  with DB do
  begin
    edtName.Text := Name;
    edtMail.Text := Mail;
    edtTel.Text := IntToStr(Number);
  end;

  CloseFile(DatBase);
end;

procedure TMainForm.ShowRecords;
var
  DatBase : file of TDatBase;
  I : Integer;
begin
  AssignFile(DatBase, DatName);
  if not FileExists(DatName) then Exit else
    Reset(DatBase);

  cmCounts.Clear; // czy list rekordw, ktre s w pliku

  {  odczytaj ilo rekordw i wczytaj do listy }
  for I := 0 to FileSize(DatBase) -1 do
  { rekordy liczone s od 0 - my wywietlimy cyfr 1 zamiast 0, itd.}
    cmCounts.Items.Add('Rekord nr ' + IntToStr(i+1));

  lblRecords.Caption := 'Ilo rekordw: ' + IntToStr(i); // na komponencie wywietl ilo

  CloseFile(DatBase);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ShowRecords; // wywietl rekordy zapisane w pliku
end;

procedure TMainForm.cmCountsChange(Sender: TObject);
begin
// zaaduj rekord, ktry zosta wybrany z listy
// waciwo ItemIndex komponentu okrelas numer pozycji, ktra zostaa kliknita
  LoadRecord(cmCounts.ItemIndex);
end;

end.
