{
  Copyright (c) 2001 - Adam Boduch
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
 { nowe nasze wyjatki }
  ELowException = class(Exception);
  EMiddleException = class(Exception);
  EHighException = class(Exception);
  
  TMainForm = class(TForm)
    btnError: TButton;
    pmPopupMenu: TPopupMenu;
    pmiELowError: TMenuItem;
    pmiEMiddleError: TMenuItem;
    pmiEHighError: TMenuItem;
    lblMessage: TLabel;
    procedure btnErrorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  { procedura obsugi wyjtkw }
    procedure ProccException(Sender: TObject; E : Exception);
  published
  { procedura obsugujca kliknicia w poszczeglne pozycje }
    procedure PopupClick(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.btnErrorClick(Sender: TObject);
var
  GetCursor : TPoint;  // nowy typ danych
begin
  GetCursorPos(GetCursor);  // pobierz aktualn pozycj kursora
  pmPopupMenu.Popup(GetCursor.X, GetCursor.Y); // wywietl menu
end;

procedure TMainForm.PopupClick(Sender: TObject);
begin
{
   odczytaj warto Tag pozycji menu, ktra zostaa nacinita.
   W zalenoci o wartoci Tag wygeneruj odpowiedni komunikat bdu.
}
  case (Sender as TMenuItem).Tag of
    1: raise ELowException.Create('Nastpi niegrony bd');
    2: raise EMiddleException.Create('Taki sobie bd. Troch grony. Zawiadom szefa');
    3: raise EHighException.Create('Woaj tego szefa do cholery!!!');
  end;
end;

procedure TMainForm.ProccException(Sender: TObject; E: Exception);
begin
{
   Procedura obsugi wyjtku. Nie wywietlaj bdu w okienku, ale wiadomo
   o bdzie wywietl na komponencie typu TLabel. Jeeli bd jest typu EHighException
   to wywietl dodatkowo komunikat.
}
  lblMessage.Caption := E.Message;
  if E.ClassType = EHighException then
    MessageBox(Handle, 'Jejejej! Co si le dzieje!', 'Uwaga! Bd', MB_OK + MB_ICONERROR);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
{ przypisz procedur obsugi wyjtku }
  Application.OnException := ProccException;
end;

end.
