
(**************************************************************)
(*           Programme searching files for Delphi 5           *)
(*         Copyright (c) 2001 by Adam Boduch                  *)
(*           Build:  25 lutego 2001 r.                        *)
(*                  Service for programmers:                  *)
(*                http://www.programowanie.of.pl              *)
(*              E-mail: boduch@poland.com                     *)
(**************************************************************)

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ImgList, FileCtrl, ShellAPI;

type
  TForm1 = class(TForm)
    DirList: TDirectoryListBox;
    Drive: TDriveComboBox;
    ImageList1: TImageList;
    ListView: TListView;
    Button1: TButton;
    Maska: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure ListViewDblClick(Sender: TObject);
  private
{ Procedura przeszukujca pliki }
    procedure FindFiles(Dir: String; Mask: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FindFiles(Dir, Mask: String);
var
  SR : TSearchRec; // rekord
  List : TListItem; // pozycja w ListView
  Found : Integer; // zmienna oznacza ilosc znalezionych plikow
  I : WORD;
  Icon : TIcon; // ikona
begin
  I := 0;
  ListView.Items.Clear; // wyczyszczenie komponentu

  Icon := TIcon.Create; // stworzenie ikony
// wyciagniecie ikony
  Icon.Handle := ExtractAssociatedIcon(hInstance, PChar(Dir + '\' + Mask), i);
  ImageList1.InsertIcon(0, Icon); // wstawienie ikony do komponentu

  Found := FindFirst(Dir + '\' + Mask, faAnyFile, SR ); // odnajd pliki
  while ( Found = 0 ) do // rob dopoki liczba zbalezionych plikow nie rowna sie zero
  begin
    List := ListView.Items.Add; // stworz nowa pozycje
    List.Caption := Dir + '\' + SR.Name; // ustaw pozycje
    List.SubItems.Add(IntToStr(SR.Size) + ' bajtw'); // dodaj rozmiar pliku
    List.ImageIndex := 0; // ustaw ikone
    Found := FindNext(SR); // kontynuuj przeszukiwanie
  end;

  FindClose(SR); // zkaoncz przeszukiwanie

  Icon.Free;  // zwolnij zmienna
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
{ Wykonaj procedure na podst. maski ustawionej w komponencie
  TEdit oraz katalogu z komponentu "DirectoryListBox" }
  FindFiles(DirList.Directory, Maska.Text);
end;

procedure TForm1.ListViewDblClick(Sender: TObject);
begin
{ Procedura otwiera wybrany plik po dwukrotnym nacisnieciu w pozycje
  na komponencie "ListView" }
 ShellExecute(Handle, 'open', PCHar(ListView.Selected.Caption), nil, nil,
 SW_SHOWNORMAL);
end;

end.
