
(**************************************************************)
(*                                                            *)
(*            Tray Demo Program for Borland Delphi            *)
(*          Copyright (c) 2001 by Adam Boduch                 *)
(*          E - mail:  boduch@poland.com                      *)
(*                                                            *)
(**************************************************************)
unit MainFrmU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellAPI, StdCtrls, Menus;

{ Komunikat obslugujacy operacje na Tray'u }
const
  WM_ICONTOTRAY = WM_USER + 1;

type
  TMainFrm = class(TForm)
    TrayMenu: TPopupMenu;
    MenuExist: TMenuItem;
    MenuAbout: TMenuItem;
    N1: TMenuItem;
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuExistClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    Tray: TNotifyIconData;
    Done : Boolean;
    procedure MoveText(Lines: TStringList); // procedura uruchamiajaca animacje
    { Obsluga komunikatu }
    procedure TrayProc(var Msg: TMessage); message WM_ICONTOTRAY;
  public
  end;

var
  MainFrm: TMainFrm;

implementation

{$R *.DFM}

procedure TMainFrm.TrayProc(var Msg: TMessage);
var
  P : TPoint;
  S : TStringList;
begin
  if Msg.LParam = WM_RBUTTONDOWN then // Jezeli nacisnieto prawy przycisk myszy...
  begin
    GetCursorPos(P); //.. pobierz wspolrzedne kursora
    TrayMenu.Popup(P.X, P.Y); // wyswietl menu
  end;

  if Msg.LParam = WM_LBUTTONDOWN then
  begin// Jezeli uzytkownik nacisnol lewy przycisk...
    ShowWindow(Handle, SW_SHOW);  // pokaz forme

    S := TStringList.Create;  // utworz zmienna
    S.Add('Tray Demo Program'); // dodaj tekst
    S.Add('HTTP://WWW.PROGRAMOWANIE.OF.PL');
    MoveText(S); // wyywolaj procedure wyswietlajaca animacje
    S.Free;
  end;
end;

procedure TMainFrm.MenuAboutClick(Sender: TObject);
begin
{ Wyswietlenie okna: "O programie..." }
  Application.MessageBox(
  '  Tray Menu Demo ' + #13#13+
  'Copyright (c) 2001 by Adam Boduch'+#13+
  'HTTP://WWW.PROGRAMOWANIE.OF.PL'+#13+
  'E-mail: boduch@poland.com', 'Info', MB_OK + MB_ICONINFORMATION);
end;

procedure TMainFrm.MoveText(Lines: TStringList);
var
  I : Integer;
  Count : Byte; // okresla linie tekstu
  S : String;
begin
{
  Ta procedura nie ma nic wspolnego z Tray'em. Po prostu
  przesuwa ona tekst na pasku tytulowym formy.
}

  Count := 0;  // wyswietl pierwsza linie tekstu
  S := Lines.Strings[Count];

  while not (Done) do
  begin
    For I := 0 to 100 do
    begin
      Application.ProcessMessages;
      Sleep(100); // odstep
      Insert(' ', S, 1); // dodaj spacje na poczatku zdania
      Caption := S;// wyswietl na pasku stanu
    if (Done) then
      Break;
     if I = 100 then // Jezeli tekst dojdzie to punktu 100...
     begin
       while Pos(' ', S) > 0 do
        Delete(S, Pos(' ', S), 1); //... usun wszystkie spacje
        Count := Succ(Count); // zwieksz licznik
{
  Zmienna "Count" przechowuje informacje o wyswietlanej linii.
  Po kazdorazowym wykonaniu tej petli licznik jest zwiekszany
  o 1 co owocuje wyswietleniem kolejnej linii.
}
          if Count = Lines.Count then Count := 0; // Jezeli nie masz wiecej linii to wyzeruj licznik
        S := Lines.Strings[Count]; // wyswiet nowa linie
     end;
    end;
  end;
  Lines.Free; // zwolnij zmienna
end;

procedure TMainFrm.MenuExistClick(Sender: TObject);
begin
{
  Procedura, ktora konczy dzialanie programu
}
  Done := True; // zatrzymaj animacje
  Shell_NotifyIcon(NIM_DELETE, @Tray); // usun ikone z Tray'a
  Application.Terminate; // zakoncz program
end;

procedure TMainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Tray.cbSize := SizeOf(Tray);
  Tray.Wnd := Handle;
  Tray.hIcon := LoadIcon(0, IDI_WINLOGO); // zaladuj ikone
  Tray.szTip := 'Program...'; // dymek podpowiedzi
  Tray.uFlags := NIF_ICON + NIF_MESSAGE + NIF_TIP; // flagi
  Tray.uCallbackMessage := WM_ICONTOTRAY;  // komunikat

  Shell_NotifyIcon(NIM_ADD, @Tray); // dodaj do Tray'a

  Action := caNone;   // nie rob nic..
{
 Action moze byc takze:
   caFree - zwolnij
   caNone - nie rob nic
   caHide - ukryj
}
  ShowWindow(Handle, SW_HIDE);
end;

end.

