(******************************************************)
(*      Instalator  v. 1.0 Source                     *)
(*                                                    *)
(*   Copyright (c) 2000/2001 by Adam boduch           *)
(*  Wszystkie prawa zastrzezone                       *)
(*     E-mail:    boduch@poland.com                   *)
(* SERVICE FOR PROGRAMMERS:                           *)
(*   http://www.programowanie.of.pl                   *)
(******************************************************)

unit MainForm;

interface

uses
  Windows, SysUtils, Forms, ActiveX,
  StdCtrls, ShellAPI, Gauges, ShlObj,
  Buttons, ExtCtrls, Classes, Graphics, Controls;

{ Stale tekstowe, ktore pojawia sie na pasku programu }
const
  BarText = 'Przykadowy instalator';
  AppName  = 'Przykadowy instalator';

  {$R FILES.RES} // plik z programem do zainstalowania


type
  TMainFrm = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Dir: TEdit;
    Gauge: TGauge;
    Browse: TSpeedButton;
    Install: TSpeedButton;
    Closebtn: TSpeedButton;
    Panel1: TPanel;
    Label2: TLabel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure BrowseClick(Sender: TObject);
    procedure ClosebtnClick(Sender: TObject);
    procedure DirKeyPress(Sender: TObject; var Key: Char);
    procedure FormPaint(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure InstallClick(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  MainFrm: TMainFrm;

implementation

{$R *.DFM}

procedure TMainFrm.FormCreate(Sender: TObject);
var
  Icon : HICON;
begin
  Caption := BarText;
  Label1.Caption := Label1.Caption + AppName;
{
  Funkcje ponizej "wyciagaja" ikone programu, ktorego zrodlo
  wlasnie czytasz :)
  Parametr "ParamStr(0)" zawiera pelna sciezke do programu,
  ktory jest wlasnie uruchomiony.
  Nastepnie ikona, ktora przechowywana jest pod zmienna
  "Icon" przypisywana jest komponentowi "Image".
}
  Icon := ExtractIcon(Handle, PChar(ParamStr(0)), 0);
  Image1.Picture.Icon.Handle := Icon;
end;

procedure TMainFrm.BrowseClick(Sender: TObject);
var BI:TBrowseInfo;
    Buf:PChar;
    Dirs,Root:PItemIDList;
    Alloc:IMalloc;
begin
 // Pobieramy obiekt zarzdzajcy pamici
 SHGetMalloc(Alloc);
 // Przydzielamy pami na string
 Buf:=Alloc.Alloc(Max_Path);

 // Ograniczamy wybr tylko do katalogu "Menu Start\Programs"
 SHGetSpecialFolderLocation(Handle,CSIDL_DESKTOP,Root);

 with BI do
 begin
  hwndOwner:= Handle;
  pidlRoot:=Root; // Tu mona poda NIL eby mona byo wybra kady katalog
  pszDisplayName:=Buf;
  lpszTitle:='Wybierz katalog'; // Etykietka przed list katalogw
  ulFlags:=0;
  lpfn:=nil;
 end;

 try
  Dirs:=SHBrowseForFolder(BI);
  if Dir<>Nil then
  begin
   // Pobieramy pen ciek do katalogu
   SHGetPathFromIDList(Dirs ,Buf);
   // Przykadowe zastosowanie
   Dir.Text := Buf;
   Alloc.Free(Dir);
  end;
 finally
  Alloc.Free(Root);
  Alloc.Free(Buf);
 end;
end;


procedure TMainFrm.ClosebtnClick(Sender: TObject);
begin
  Close; // zamknij program
end;

procedure TMainFrm.DirKeyPress(Sender: TObject; var Key: Char);
begin
{
  Procedura przechodzi do innej procedury "Install", ktora
  powoduje zainstalowanie programu wtedy gdy uzytkownik
  nacisnie klawisz ENTER.
}
 if Key = #13 then
  begin
    InstallClick(Sender); // przejdz do procedury
    Key := #0; // nie generuj sygnalu
  end;
end;

procedure TMainFrm.FormPaint(Sender: TObject);
begin
{
  Procedura ta wyswietla na formie tekst ( nazwe programu
  do instalacji ). Tekst jest rysowany dwa razy dzieki
  czemu odnosi sie wrazenie rzucania ciena przez tekst.
}
  Canvas.Font.Name := 'Arial Black'; // ustaw czcionke
  Canvas.Font.Size := 20;
  Canvas.Font.Color := clGray; // kolor czcionki
  Canvas.Brush.Color := clSilver;
  Canvas.TextOut(90, 6, AppName); // wyswietl napis
  Canvas.Brush.Style := bsClear; // tlo jako przezroczyste
  Canvas.Font.Color := clBlack;  // zmien kolor czcionki
  Canvas.TextOut(92, 8, AppName); // wyswietl text jeszcze raz
end;

procedure TMainFrm.Label2Click(Sender: TObject);
begin
// uruchamia przegladarke internetowa i laduje strone: WWW.PROGRAMOWANIE.OF.PL
  ShellExecute(Handle, 'open', 'www.programowanie.of.pl', nil, nil, SW_SHOWMAXIMIZED);
end;

procedure TMainFrm.InstallClick(Sender: TObject);
{
  Rekord ten zawiera dwie pozycje. Pierwsza okresla tutul
  instalowanego pliku, ktory okresliles podczas kompilacji
  zasobow. Drugi to dokladna nazwa instalowanego pliku - np: Pad.exe
}
type
  _DATA = record
    Title: PChar;
    FName: PChar;
  end;
{
  Stala okreslajaca tablice bazujaca na rekordzie. Tablica ta
  zawiera dokladna nazwe pliku jaki bedzie stworzony podczas
  instalacji oraz nazwa, ktora zostala podana podczas kompilacji
  zasobow.
}
const
  Files : array [0..1] of _DATA =
  ((Title: 'PAD'; FName: 'Pad.exe'),
  (Title: 'README'; FName: 'Readme.txt'));
var
  Res : TResourceStream;
  I : Integer;
{
  Procedura, korej tresc widzisz pokazuje wskaznik postepu
  na pasku "Gauge". Jest to tylko tak dla "bajeru", aby pokazac
  postep w kopiowaniu pliki :)
}
  procedure Postep;
  var
    I : Integer;
  begin
    For I := 0 to 100 do  // petla
    begin
      Application.ProcessMessages;
      Sleep(3); // czekaj 3 milisekundy
      Gauge.Progress := i;
    end;
  end;

begin
{
  Jezeli ostatnim znamiem znajdujacym sie w "Dir" jest znak "\" to nie
  rob nic. Jezeli jest inaczej dopisz ten znak na koncu tekstu.
}
    if Dir.Text[Length(Dir.Text)] = '\' then
      Dir.Text := Dir.Text else
    Dir.Text := Dir.Text + '\';

  For I := Low(Files) to High(Files) do
  begin
    Application.ProcessMessages; // daj odetchnac systemowi
    Postep;  // wywyolaj procedure
    Res := TResourceStream.Create(hInstance, Files[i].Title, RT_RCDATA);
    Res.SaveToFile(Dir.Text + Files[i].FName);// zapisz plik na dysku
    Res.Free; // zwolnij zmienna
  end;

  MessageBox(Handle, 'Instalacja zakoczona sukcesem :)', 'Informacja',
  MB_OK + MB_ICONINFORMATION);
end;

end.
